<template>
  <div>
    <v-list class="pa-0">
      <v-list-item
        v-for="(lang, i) in value[mode]"
        :key="i"
        style="background-color: #f5f5f5; border-radius: 5px"
        class="mb-4"
      >
        <v-list-item-content>
          <v-list-item-title
            ><span class="grey--text text--darken-2" style="font-size: 12px">{{
              $t(`dcc.administrativeData.coreData.${mode}.title`)
            }}</span
            ><span
              v-if="i === 0"
              class="red--text text--darken-2"
              style="font-size: 12px"
            >
              *</span
            ><br /><span style="color: black"
              >{{ lang._text }} - {{ iso639Names[lang._text] }}</span
            ></v-list-item-title
          >
        </v-list-item-content>
        <div v-if="i > 0">
          <v-tooltip bottom>
            <template #activator="{ on }">
              <v-btn
                icon
                small
                :aria-label="
                  $t(`dcc.administrativeData.coreData.${mode}.delete`)
                "
                v-on="on"
                @click="
                  mode === 'mandatoryLangCodeISO639_1'
                    ? deleteMandatoryLang(lang._text)
                    : deleteUsedLang(lang._text)
                "
              >
                <v-icon>delete</v-icon>
              </v-btn>
            </template>
            <span>{{
              $t(`dcc.administrativeData.coreData.${mode}.delete`)
            }}</span>
          </v-tooltip>
        </div>
      </v-list-item>
    </v-list>
  </div>
</template>

<script>
import { DCCDocument } from "@d-ptb/dcc-js";
import ISO639 from "~/assets/lists/iso-639-codes";

export default {
  name: "GLanguageList",
  components: {},
  props: {
    value: Object,
    mode: {
      type: String,
    },
  },
  computed: {
    iso639Names() {
      const langNames = {};
      ISO639.map((x) => (langNames[x.code] = x.name));
      return langNames;
    },
    iso639() {
      return ISO639;
    },
  },
  methods: {
    deleteMandatoryLang(langCode) {
      this.value.mandatoryLangCodeISO639_1 =
        this.value.mandatoryLangCodeISO639_1.filter((item) => {
          return item._text !== langCode;
        });
    },
    deleteUsedLang(langCode) {
      if (
        confirm(
          this.$t(
            "dcc.administrativeData.coreData.usedLangCodeISO639_1.deleteConfirm"
          )
        )
      ) {
        const parser = new DOMParser();
        const xmlDoc = parser.parseFromString(
          this.$global.dccDocument.toXML(),
          "text/xml"
        );

        const nodesToRemove = xmlDoc.querySelectorAll(
          `content[lang="${langCode}"]`
        );
        nodesToRemove.forEach((node) => node.parentNode.removeChild(node));

        const xml = new XMLSerializer().serializeToString(xmlDoc);
        this.$global.dccDocument = DCCDocument.fromXml(xml);

        this.$nextTick(() => {
          this.value.usedLangCodeISO639_1 =
            this.value.usedLangCodeISO639_1.filter((item) => {
              return item._text !== langCode;
            });
          this.deleteMandatoryLang(langCode);
        });
      }
    },
  },
};
</script>
